#pragma once

#include "define.h"
#include "DisplayDriver.h"

class Display
{
  IDisplayDriver &driver;
  
public:
  Display( IDisplayDriver &_driver ) : driver(_driver){}
  
  void Line( const Point &pt0, const Point &pt1, const uint8_t w, const uint16_t color );
  void FillRect( const Point &pt0, const Point &pt1, const uint16_t color );
  void Rect( const Point &pt0, const Point &pt1, const uint8_t w, const uint16_t color );
  void FillCircle( const Point &pt0, const uint8_t r, const uint16_t color );
  void Circle( const Point &pt0, const uint8_t &r, const uint8_t w, const uint16_t color );
  void Arc( const Point &pt0, const uint8_t r, uint16_t a1, uint16_t a2, const uint16_t color );
};