#include "DisplayDriver.h"


//------------------------------------------------------------------------------
void IDisplayDriver::sendCommand( const uint8_t cmd )
{
//  CS.Clear();
  DC.Clear();
  spi->sendByte( cmd );
//  CS.Set();
}
//------------------------------------------------------------------------------
void IDisplayDriver::sendData( const uint8_t data )
{
//  CS.Clear();
  DC.Set();
  spi->sendByte( data );
//  CS.Set();
}
//------------------------------------------------------------------------------
void IDisplayDriver::sendArrData( uint8_t *data, const uint8_t len )
{
//  CS.Clear();
  DC.Set();
  spi->sendData( data, len );
//  CS.Set();
}
//------------------------------------------------------------------------------
void IDisplayDriver::reset()
{

}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void ST7789::Init()
{
 
}
//------------------------------------------------------------------------------
void ST7789::Clear()
{

}
//------------------------------------------------------------------------------
void ST7789::Display( const Point &pt0, const Point &pt1, const uint16_t color )
{

}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void ST7735::Init()
{
  CS.Clear();          // CS_LOW;
  RES.Set();           //RESET_HIGH;
  HAL_Delay(5);
  RES.Clear();         //RESET_LOW;
  HAL_Delay(5);
  RES.Set();            //RESET_HIGH;
  HAL_Delay(5);

  sendCommand(SWRESET);  
  HAL_Delay(150);
  sendCommand(SLPOUT);
  HAL_Delay(200);

  sendCommand(FRMCTR1);
  sendData(0x01);
  sendData(0x2C);
  sendData(0x2D);

  sendCommand(FRMCTR2);
  sendData(0x01);
  sendData(0x2C);
  sendData(0x2D);

  sendCommand(FRMCTR3);
  sendData(0x01);
  sendData(0x2C);
  sendData(0x2D);
  sendData(0x01);
  sendData(0x2C);
  sendData(0x2D);

  sendCommand(INVCTR);
  sendData(0x07);

  sendCommand(PWCTR1);			//???
  sendData(0xA2);
  sendData(0x02);
  sendData(0x84);

  sendCommand(PWCTR2);			//???
  sendData(0xC5);

  sendCommand(PWCTR3);
  sendData(0x0A);
  sendData(0x00);

  sendCommand(PWCTR4);
  sendData(0x8A);
  sendData(0x2A);

  sendCommand(PWCTR5);
  sendData(0x8A);
  sendData(0xEE);

  sendCommand(VMCTR1);
  sendData(0x0E);

  sendCommand(INVOFF);

  sendCommand(MADCTL);
  sendData(0xC0);

  sendCommand(COLMOD);
  sendData(0x05);

  sendCommand(GAMCTRP1);
  sendData(0x02);
  sendData(0x1C);
  sendData(0x07);
  sendData(0x12);
  sendData(0x37);
  sendData(0x32);
  sendData(0x29);
  sendData(0x2D);
  sendData(0x29);
  sendData(0x25);
  sendData(0x2B);
  sendData(0x39);
  sendData(0x00);
  sendData(0x01);
  sendData(0x03);
  sendData(0x10);

  sendCommand(GAMCTRN1);
  sendData(0x03);
  sendData(0x1D);
  sendData(0x07);
  sendData(0x06);
  sendData(0x2E);
  sendData(0x2C);
  sendData(0x29);
  sendData(0x2D);
  sendData(0x2E);
  sendData(0x2E);
  sendData(0x37);
  sendData(0x3F);
  sendData(0x00);
  sendData(0x00);
  sendData(0x02);
  sendData(0x10);

  sendCommand(NORON);
  HAL_Delay(50);

  sendCommand(DISPON);
  HAL_Delay(150);

  CS.Set();  //CS_HIGH;
}
//------------------------------------------------------------------------------
void ST7735::Clear()
{
  
}
//------------------------------------------------------------------------------
void ST7735::Display( const Point &pt0, const Point &pt1, const uint16_t color )
{ 
  uint8_t col[4];
  uint8_t row[4];
  CS.Clear();
  
  col[0] = (pt0.x & 0xFF00) >> 8;
  col[1] = pt0.x & 0x00FF;
  col[2] = (pt1.x & 0xFF00) >> 8;
  col[3] = pt1.x & 0x00FF;
  sendCommand( CASET );
  sendArrData( col, 4 );

  row[0] = (pt0.y & 0xFF00) >> 8;
  row[1] = pt0.y & 0x00FF;
  row[2] = (pt1.y & 0xFF00) >> 8;
  row[3] = pt1.y & 0x00FF;
  sendCommand( RASET );
  sendArrData( row, 4 );
  
  sendCommand( RAMWR );
  uint8_t colorByte[2];
  colorByte[0] = (color & 0xFF00) >> 8;
  colorByte[1] = color & 0x00FF;

  DC.Set();
  uint32_t size = ( pt1.x - pt0.x ) * ( pt1.y - pt0.y );
  
  for ( uint32_t sz = 0; sz < size; sz++ )
  {
    spi->sendByte( colorByte[0] );
    spi->sendByte( colorByte[1] );
  }
  
  CS.Set();
}













