#include "SPI.h"

//------------------------------------------------------------------------------
void SPI::initSPI()
{
  SET_BIT( reg->CR1, SPI_CR1_SPE );
}
//------------------------------------------------------------------------------
void SPI::sendByte( uint8_t byte )
{
  while( !(reg->SR & SPI_SR_TXE) ) {}
  reg->DR = byte;
  while( reg->SR & SPI_SR_BSY ) {}
}
//------------------------------------------------------------------------------
void SPI::sendData( const void *arr, uint8_t length )
{
  assertm( length > 0, "Length must be more null" );
  
  uint8_t *p = (uint8_t *)arr;
  while( length-- )
      sendByte( *p++ );
}
//------------------------------------------------------------------------------
uint8_t SPI::readByte()
{
  while( READ_BIT(reg->SR, SPI_SR_BSY ) != 0 )  ;
  uint8_t tmp = reg->DR;
  reg->DR = 0;
  while( READ_BIT(reg->SR, SPI_SR_RXNE) == 0 )  ;
  return reg->DR;
}
//------------------------------------------------------------------------------
void SPI::readData( void *data, uint8_t length )
{
  uint8_t *p = (uint8_t*)data;
  while( length-- ) *p++ = readByte();
}
//------------------------------------------------------------------------------













