#pragma once

#include "define.h"
#include "adc.h"

class IVariable
{
protected:
  const Adc *pAdc;
  float val = 0.0F;
  
public:
  explicit IVariable( const Adc *_pAdc ) : pAdc( pAdc ){} 
  
  virtual float calculate() = 0;
  float value() const { return val; }
};
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
class Temperature : public IVariable
{
  const uint16_t voltage = 760;
  const float average = 2.5;
  
public:
  explicit Temperature( const Adc *_pAdc ) : IVariable(_pAdc){}
  
  float calculate() override;
};
/*----------------------------------------------------------------------------*/
class RefVoltage : public IVariable
{
public:
  explicit RefVoltage( const Adc *_pAdc ) : IVariable(_pAdc){}
  
  float calculate() override;
};
/*----------------------------------------------------------------------------*/
class Sensor : public IVariable
{
public:
  explicit Sensor( const Adc *_pAdc ) : IVariable(_pAdc){}
  
  float calculate() override;
};
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/






