#pragma once

#include "define.h"
#include <array>

#define ARR_ADC         3

//struct IDma
//{
//  virtual void initDMA() = 0;
//  virtual void* value( uint16_t idx ) = 0;
//};
//
//template< typename T, uint32_t capacity >
//class Dma : public IDma
//{
//  std::array< T, capacity > buffer;
//  DMA_Stream_TypeDef *stream;
//
//  uint32_t addrPeriph;
//  
//public:
//  Dma( DMA_Stream_TypeDef *_stream, const uint32_t _addrPeriph )
//  {
//    stream      = _stream;
//    addrPeriph  = _addrPeriph;
//  }
//  
//  void initDMA() override
//  {
//    stream->CR &= ~DMA_SxCR_EN;
//    stream->PAR |= addrPeriph;
//    stream->M0AR |= (uint32_t)&buffer[0];
//    stream->NDTR |= capacity;
//    stream->CR |= DMA_SxCR_EN;
//  }
//  
//  void* value( uint16_t idx ) override { return &buffer.at( idx ); }
//};

/*----------------------------------------------------------------------------*/
class IDma
{
protected:
  DMA_Stream_TypeDef *stream;
  uint32_t addrPeriph;
  
public:
  IDma( DMA_Stream_TypeDef *_stream, const uint32_t _addrPeriph ) 
    : stream(_stream), addrPeriph(_addrPeriph){}
  
  virtual void initDMA() = 0;
  virtual uint32_t value( uint16_t idx ) = 0;
};
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
class DmaAdc : public IDma
{
public:
  std::array< uint16_t, ARR_ADC > pBuff;
  
public:
  DmaAdc( DMA_Stream_TypeDef *_stream, const uint32_t _addrPeriph )
    : IDma( _stream, _addrPeriph ){}
    
  void initDMA() override;   
  uint32_t value( uint16_t idx ) override;
};
/*----------------------------------------------------------------------------*/








